/* $Header: patnfs.c,v 1.1 87/02/08 01:08:06 notes Exp $ */

#define dprintf if (0) printf

/*
 * Expand patterns.
 * Entry points are dopat and checkpat.
 *
 *	Lou Salkind
 *	New York University
 *   This version has been slightly revised for use by nfsearch,
 *   by Stan Isaacs, hpccc, 8/29/86.
 *
 *   Only the dopat functions has been changed, to return the "next"
 *   valid name each time it is called.  The new name is retpat.
 */

#include "parms.h"
#include "structs.h"
#include <sys/stat.h>

#include <stdio.h>

static char **basep;
static int nitems = 0;

char *malloc();
#ifdef __STDC__
int initdir(char*,char*);
int match(char*,char*);
#else
int initdir();
int match();
#endif

/*
 * retpat searches for a match to pattern "s" in the active notes list.
 *      It starts at the "next" item in the list, and returns the number
 *      to start at next, or zero if no match is found.  The pointer to
 *      the active notesfile is returned in "ip".
 */

retpat(next,s,name)
        int next;
	char *s;
	char **name;
{
	char *ip;
	int i;
	static int inited;

	if (inited == 0) {
              if (initdir(spooldir, "") < 0) return 0;
		inited++;
	}
	for (i = next; i < nitems; i++) {
		*name = ip = basep[i];
		if (match(s, ip))
			return (i+1);
	}
	return 0;
}
